apps/tasks/urls.py
from django.urls import path

from . import views

app_name = 'tasks'

urlpatterns = [
    path('categorias/', views.list_categories, name='list_categories'),
    path('categorias/adicionar/', views.add_category, name='add_category'),
    path('categorias/editar/<int:id_category>/', views.edit_category, name='edit_category'),
    path('categorias/excluir/<int:id_category>/', views.delete_category, name='delete_category'),
    path('adicionar/', views.add_task, name='add_task'),
    path('editar/<int:id_task>/', views.edit_task, name='edit_task'),
    path('excluir/<int:id_task>/', views.task_delete, name='task_delete'),
    path('', views.tasks_list, name='tasks_list'),
]

todoapp/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf import settings
from django.conf.urls.static import static


urlpatterns = [
    path('admin/', admin.site.urls),
    path('tarefas/', include('tasks.urls', namespace='tasks')),
    path('contas/', include('accounts.urls', namespace='accounts')),
    path('', include('core.urls', namespace='core')),
]

urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)
# urlpatterns += static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)

apps/tasks/models.py
from django.db import models

from django.contrib.auth.models import User

# Create your models here.

class Category(models.Model):
    name = models.CharField('Nome', max_length=150)
    description = models.TextField('Descrição', blank=True, null=True)
    owner = models.ForeignKey(User, on_delete=models.CASCADE)

    class Meta:
        verbose_name = 'Categoria'
        verbose_name_plural = 'Categorias'
        ordering = ['id']
    
    def __str__(self):
        return self.name

class Task(models.Model):
    PRIORITY_CHOICES = (
        ('B', 'Baixa'),
        ('M', 'Média'),
        ('A', 'Alta'),
    )
    STATUS_CHOICES = (
        ('EX', 'Em execução'),
        ('PD', 'Pendente'),
        ('CD', 'Concluída'),
    )
    name = models.CharField('Tarefa', max_length=200)
    description = models.TextField('Descrição')
    end_date = models.DateField('Data final', auto_now=False, auto_now_add=False)
    priority = models.CharField('Prioridade', max_length=1, choices=PRIORITY_CHOICES)
    category = models.ManyToManyField(Category)
    status = models.CharField('Status', max_length=2, choices=STATUS_CHOICES)
    owner = models.ForeignKey(User, on_delete=models.CASCADE)

    class Meta:
        verbose_name = 'Tarefa'
        verbose_name_plural = 'Tarefas'
        ordering = ['id']
    
    def __str__(self):
        return self.name
    
    def list_categories(self):
        return ", ".join([c.name for c in self.category.all()])
    list_categories.short_description = "Categorias"

apps/tasks/forms.py
from django import forms

from .models import Task, Category

class CategoryForm(forms.ModelForm):

    class Meta:
        model = Category
        exclude = ('owner',)

class TaskForm(forms.ModelForm):

    class Meta:
        model = Task
        exclude = ('owner',)

apps/tasks/views.py
from django.shortcuts import render, get_object_or_404, redirect
from django.contrib import messages
from django.contrib.auth.decorators import login_required

from .forms import CategoryForm, TaskForm
from .models import Category, Task

# Create your views here.

@login_required(login_url='/contas/login/')
def add_category(request):
    template_name = 'tasks/add_category.html'
    context = {}
    if request.method == 'POST':
        form = CategoryForm(request.POST)
        if form.is_valid():
            f = form.save(commit=False)
            f.owner = request.user
            f.save()
            messages.success(request, 'Categoria adicionada com sucesso')
    form = CategoryForm()
    context['form'] = form
    return render(request, template_name, context)

@login_required(login_url='/contas/login/')
def list_categories(request):
    template_name = 'tasks/list_categories.html'
    categories = Category.objects.filter(owner=request.user)
    context = {
        'categories': categories
    }
    return render(request, template_name, context)

@login_required(login_url='/contas/login/')
def edit_category(request, id_category):
    template_name = 'tasks/add_category.html'
    context = {}
    category = get_object_or_404(Category, id=id_category, owner=request.user)
    if request.method == 'POST':
        form = CategoryForm(request.POST, instance=category)
        if form.is_valid():
            form.save()
            return redirect('tasks:list_categories')
    form = CategoryForm(instance=category)
    context['form'] = form
    return render(request, template_name, context)

@login_required(login_url='/contas/login/')
def delete_category(request, id_category):
    category = Category.objects.get(id=id_category)
    if category.owner == request.user:
        category.delete()
    else:
        messages.error(request, 'Você não tem permissão para excluir esta categoria.')
        return redirect('core:home')
    return redirect('tasks:list_categories')

@login_required(login_url='/contas/login/')
def add_task(request):
    template_name = 'tasks/add_task.html'
    context = {}
    if request.method == 'POST':
        form = TaskForm(request.POST)
        if form.is_valid():
            f = form.save(commit=False)
            f.owner = request.user
            f.save()
            form.save_m2m()
            messages.success(request, 'Tarefa adicionada com sucesso.')
        else:
            print(form.errors)
    form = TaskForm()
    context['form'] = form
    return render(request, template_name, context)

@login_required(login_url='/contas/login/')
def tasks_list(request):
    template_name = 'tasks/tasks_list.html'
    context = {}
    tasks = Task.objects.filter(owner=request.user).exclude(status='CD')
    context['tasks'] = tasks
    return render(request, template_name, context)

@login_required(login_url='/contas/login/')
def edit_task(request, id_task):
    template_name = 'tasks/add_task.html'
    context = {}
    task = get_object_or_404(Task, pk=id_task, owner=request.user)
    if request.method == 'POST':
        form = TaskForm(request.POST, instance=task)
        if form.is_valid():
            form.save()
            return redirect('tasks:tasks_list')
    form = TaskForm(instance=task)
    context['form'] = form
    return render(request, template_name, context)

@login_required(login_url='/contas/login/')
def task_delete(request, id_task):
    task = Task.objects.get(id=id_task)
    if task.owner == request.user:
        task.delete()
    else:
        messages.error(request, 'Você não tem permissão para excluir esta tarefa.')
        return redirect('core:home')
    return redirect('tasks:tasks_list')

templates/tasks/add_category.html
{% extends 'base.html' %}

{% load widget_tweaks %}

{% block title %}

    Adicionar Categoria - {{ block.super }}

{% endblock title %}


{% block body %}
    <div class="container">
        <h1>Categoria</h1>
        {% include 'partials/messages.html' %}
        <div class="row">
            <div class="col-md-12">
                <form action="." method="POST" autocomplete="off">
                {% csrf_token %}
                <div class="form-group">
                    <label for="{{ form.name.id_for_label }}">Nome</label>
                    {{ form.name|add_class:"form-control"|attr:"autofocus" }}
                </div>
                <div class="form-group">
                    <label for="{{ form.description.id_for_label }}">Descrição</label>
                    {{ form.description|add_class:"form-control" }}
                </div>

                <button type="submit" class="btn btn-primary">Salvar</button>
                </form>
            </div>
        </div>
    </div>


{% endblock body %}
    

templates/tasks/add_task.html
{% extends 'base.html' %}

{% load widget_tweaks %}

{% block title %}

    Adicionar Tarefa - {{ block.super }}

{% endblock title %}


{% block body %}
    <div class="container">
        <h1>Tarefa</h1>
        {% include 'partials/messages.html' %}
        <div class="row">
            <div class="col-md-12">
                <form action="." method="POST" autocomplete="off">
                {% csrf_token %}
                <div class="form-group">
                    <label for="{{ form.name.id_for_label }}">Nome</label>
                    {{ form.name|add_class:"form-control"|attr:"autofocus" }}
                </div>
                <div class="form-group">
                    <label for="{{ form.description.id_for_label }}">Descrição</label>
                    {{ form.description|add_class:"form-control" }}
                </div>
                <div class="form-group">
                    <label for="{{ form.end_date.id_for_label }}">Data final</label>
                    {{ form.end_date|add_class:"form-control" }}
                </div>
                <div class="form-group">
                    <label for="{{ form.priority.id_for_label }}">Prioridade</label>
                    {{ form.priority|add_class:"form-control" }}
                </div>
                <div class="form-group">
                    <label for="{{ form.category.id_for_label }}">Categoria</label>
                    {{ form.category|add_class:"form-control" }}
                </div>
                <div class="form-group">
                    <label for="{{ form.status.id_for_label }}">Status</label>
                    {{ form.status|add_class:"form-control" }}
                </div>

                <button type="submit" class="btn btn-primary">Salvar</button>
                </form>
            </div>
        </div>
    </div>


{% endblock body %}
    

templates/tasks/list_categories.html
{% extends 'base.html' %}

{% load widget_tweaks %}

{% block title %}

    Adicionar Categoria - {{ block.super }}

{% endblock title %}


{% block body %}
    <div class="container">
        <h1>Lista de Categorias</h1>
        <div class="row">
            <div class="col-md-12">
                <table class="table table-hover">
                    <thead>
                        <tr>
                            <th scope="col">#</th>
                            <th scope="col">Categoria</th>
                            <th scope="col">Descrição</th>
                            <th scope="col">Ações</th>
                        </tr>
                    </thead>
                    <tbody>
                        {% for category in categories %}
                            <tr>
                                <th scope="row">{{ category.id }}</th>
                                <td>{{ category.name }}</td>
                                <td>{{ category.description }}</td>
                                <td>
                                    <a href="{% url 'tasks:edit_category' category.id %}" class="btn btn-primary btn-sm">Editar</a>
                                    <a href="{% url 'tasks:delete_category' category.id %}" class="btn btn-danger btn-sm confirm-delete" data-toggle="modal", data-target="#confirmDeleteModal" id="deleteButton-{{ category.id }}">Excluir</a>
                                </td>
                            </tr>
                        {% endfor %}
                    </tbody>
                </table>
            </div>
        </div>
        {% include 'partials/confirm_delete_modal.html' %}
    </div>
{% endblock body %}
    

templates/tasks/tasks_list.html
{% extends 'base.html' %}

{% load widget_tweaks %}

{% block title %}

    Lista de Tarefas - {{ block.super }}

{% endblock title %}


{% block body %}
    <div class="container">
        <h1>Lista de Tarefas</h1>
        <div class="row">
            <div class="col-md-12">
                <table class="table table-hover">
                    <thead>
                        <tr>
                            <th scope="col">#</th>
                            <th scope="col">Tarefa</th>
                            <th scope="col">Descrição</th>
                            <th scope="col">Data Final</th>
                            <th scope="col">Prioridade</th>
                            <th scope="col">Ações</th>
                        </tr>
                    </thead>
                    <tbody>
                        {% for task in tasks %}
                            <tr>
                                <th scope="row">{{ task.id }}</th>
                                <td>{{ task.name }}</td>
                                <td>{{ task.description }}</td>
                                <td>{{ task.end_date }}</td>
                                <td>{{ task.get_priority_display }}</td>
                                <td>
                                    <a href="{% url 'tasks:edit_task' task.id %}" class="btn btn-primary btn-sm">Editar</a>
                                    <a href="{% url 'tasks:task_delete' task.id %}" class="btn btn-danger btn-sm confirm-delete" data-toggle="modal", data-target="#confirmDeleteModal" id="deleteButton-{{ category.id }}">Excluir</a>
                                </td>
                            </tr>
                        {% endfor %}
                    </tbody>
                </table>
            </div>
        </div>
        {% include 'partials/confirm_delete_modal.html' %}
    </div>
{% endblock body %}
    